#!/bin/sh

# In dhcpd.conf
# 	option TeleTec.update_sboot code 25 = text;
# Append in file /etc/init.d  variable vendorspecinf
#	upd_sboot,25,string:upd_sb_ver,28,string
# In file /etc/udhcpc/default.bound
# if [ -n "$upd_sboot" ]; then
#   /usr/bin/update_second_boot.sh $upd_sboot $upd_sb_ver
# fi

par=/ram/SbootIm

if [ "$1" == "" ]; then
  exit 1
fi
up_url=$1
rm -f $tmpfile 2>/dev/null 1>/dev/null

if [ -f /ram/mag250 ]; then
   max=327680
   ver_boot=`awk '{ if(index($0,"MAG250 Upgrade Ver.")) {print substr($0,index($0,"MAG250 Upgrade Ver.")+length("MAG250 Upgrade Ver."),3); exit; } }' /dev/mtd1`
elif [ -f /ram/mag255 ]; then
   max=327680
   ver_boot=`awk '{ if(index($0,"MAG255 Upgrade Ver.")) {print substr($0,index($0,"MAG255 Upgrade Ver.")+length("MAG255 Upgrade Ver."),3); exit; } }' /dev/mtd1`
elif [ -f /ram/mag270 ]; then
   max=327680
   ver_boot=`awk '{ if(index($0,"MAG270 Upgrade Ver.")) {print substr($0,index($0,"MAG270 Upgrade Ver.")+length("MAG270 Upgrade Ver."),3); exit; } }' /dev/mtd1`
else
   max=262144
   ver_boot=`awk '{ if(index($0,"MAG200 Upgrade Ver.")) {print substr($0,index($0,"MAG200 Upgrade Ver.")+length("MAG200 Upgrade Ver."),3); exit; } }' /dev/mtd1`
fi
 
#echo "Versions $2 and $ver_boot"
if [ "$2" == "$ver_boot" ]; then
    tmp=`fw_printenv bootupgrade 2>/dev/null`
    tmp=${tmp#bootupgrade=}
    if [ "$tmp" != "yes" ]; then
      fw_setenv bootupgrade yes
    fi
    echo "Version of Second Bootloader equal."
    exit 0
fi

URL_HTTP=`echo $up_url |awk '{ if($1~/^http:\/\//) {print $1; exit; } }'`
TFTP_IP=`echo $up_url |awk '{ if($1~/^tftp:\/\//) { tmp = substr($1,8); i=index(tmp,"/"); print substr(tmp,1,i-1); exit; } }'`
TFTP_ROOTPATH=`echo $up_url |awk '{ if($1~/^tftp:\/\//) { tmp = substr($1,8); i=index(tmp,"/"); print substr(tmp,i+1); exit; } }'`
  
if [ "$URL_HTTP" == "" ]; then
  if [ "$TFTP_IP" == "" ] || [ "$TFTP_ROOTPATH" == "" ]; then
    echo "Error: Url ($1) not correct."
    exit 1
  else
    /bin/tftp -l /proc/self/fd/1 -g -r $TFTP_ROOTPATH $TFTP_IP 2>/dev/null | dd of=$par bs=1 count=$max 2>/dev/null 1>/dev/null
  fi
else
  /bin/wget $URL_HTTP  -O /dev/stdout 2>/dev/null | dd of=$par bs=1 count=$max 2>/dev/null 1>/dev/null
fi

if [ ! -e $par ]; then
  echo "Error: File $par not present!!!"
  exit 1    
fi

f=`wc -c $par`
size=${f%%$par}
size=$((size))

echo $size

if [ $size -eq 0 ]; then
    echo "ERROR: Uploading is failed."
    exit 1;
fi
if [ $max -lt $size ]; then
    echo "ERROR: File size more then $max."
    rm -f $par 2>/dev/null 1>/dev/null    
    exit 1;
fi

dd if=/dev/mtd1 of=/ram/mtd1 bs=1 count=$size
diff $par  /ram/mtd1 > /dev/null
if [ "$?" == "0" ]; then
  echo "Second image of bootloader is up to date"
else
  flash_eraseall /dev/mtd1
  cat $par > /dev/mtd1
fi
rm -f /ram/mtd1 2>/dev/null 1>/dev/null
rm -f $par 2>/dev/null 1>/dev/null

tmp=`fw_printenv bootupgrade 2>/dev/null`
tmp=${tmp#bootupgrade=}
if [ "$tmp" != "yes" ]; then
  fw_setenv bootupgrade yes
fi
exit 0
